//+------------------------------------------------------------------+
//|                                                          AMA.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, by konKop,wellx"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Orange
#property indicator_width1  2

//---- input parameters
extern int       periodAMA=9;
extern int       nfast=2;
extern int       nslow=30;
extern double    G=2.0;
extern double    dK=2.0; 

//---- buffers
double kAMAbuffer[];
double kAMAupsig[];
double kAMAdownsig[];
double binary[];

//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,binary);
   SetIndexBuffer(1,kAMAbuffer);
   SetIndexBuffer(2,kAMAupsig);
   SetIndexBuffer(3,kAMAdownsig);
   IndicatorDigits(4);
   
   return(0);
}
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

    
   double slowSC=(2.0 /(nslow+1));
   double fastSC=(2.0 /(nfast+1));
   
   for(int pos=limit; pos>=0; pos--)
   {
      double signal=MathAbs(Close[pos]-Close[pos+periodAMA]);
      double noise=0.000000001;
      for(int i=0;i<periodAMA;i++)
           noise  = noise+MathAbs(Close[pos+i]-Close[pos+i+1]);
      double ER   = signal/noise;
      double dSC  = (fastSC-slowSC);
      double ERSC = ER*dSC;
      double SSC  = ERSC+slowSC;
            kAMAbuffer[pos] = kAMAbuffer[pos+1]+(MathPow(SSC,G)*(Close[pos]-kAMAbuffer[pos+1]));

      double ddK = (kAMAbuffer[pos]-kAMAbuffer[pos+1]);
      if ((MathAbs(ddK)) > (dK*Point) && (ddK > 0)) kAMAupsig[pos]  =kAMAbuffer[pos]; else kAMAupsig[pos]   = EMPTY_VALUE;
      if ((MathAbs(ddK)) > (dK*Point) && (ddK < 0)) kAMAdownsig[pos]=kAMAbuffer[pos]; else kAMAdownsig[pos] = EMPTY_VALUE; 
      binary[pos]=0;
         if (kAMAupsig[pos]   != EMPTY_VALUE) binary[pos] =  1;
         if (kAMAdownsig[pos] != EMPTY_VALUE) binary[pos] = -1;
         
   }
   return(0);
}

